pi = math.pi
gr = love.graphics
math.randomseed(os.time())
_f = math.floor
function love.load()
  debugVar = false
	gr.setFont(love._vera_ttf, 14)

  swidth = 800
  sheight = 600

  world = love.physics.newWorld(0,-1000, swidth, 10000, 0, 150)
	world:setMeter(200)

	menuLogo = gr.newImage("logo.png")
	logo = {}
	logo[1] = gr.newQuad(0,0,256,56,menuLogo:getWidth(),menuLogo:getHeight())
	logo[2] = gr.newQuad(0,60,133,28,menuLogo:getWidth(),menuLogo:getHeight())

  logoBox_shape = {}
  logoBox = love.physics.newBody(world, 620, -256, 0)
	logoBox_shape[1] = love.physics.newRectangleShape(logoBox, -256, -52, 512, 104, 0)
  logoBox:setMassFromShapes()
  logoBox:setAngle(degToRad(-20))
  logoBox:setBullet(true)
  logoBox_shape[1]:setRestitution(0.4)
	logoBox_shape[1]:setData("Logo")

  presentsBox_shape = {}
  presentsBox = love.physics.newBody(world, 650, -350, 0)
	presentsBox_shape[1] = love.physics.newRectangleShape(presentsBox, -133, -24, 266, 48, 0)
  presentsBox:setAngle(degToRad(5))
  presentsBox:setBullet(true)
  presentsBox_shape[1]:setRestitution(0.2)
  presentsBox:setAngularVelocity(.1)
	presentsBox_shape[1]:setData("Presents")

  ground = love.physics.newBody(world, 0, 0, 0)
	ground_shape = love.physics.newRectangleShape(ground, swidth/2, sheight/2+64, swidth, 100, degToRad(0))
  ground:setBullet(true)
	ground_shape:setData("Ground")

  world:setGravity(0,500)
	world:setCallbacks(colAdd, colPersist, colRemove)
	world:setAllowSleep(true)

	gr.setLineWidth(2)
	gr.setColorMode("modulate")
	gr.setBlendMode("alpha")
	menuLogo:setFilter("nearest","nearest")

	logoGround = true
	presentsDropped = false

	logoFade = 0
	logoFadeTo = 0
end

function love.update(dt)
  if love.timer.getTime() > 5 and logoGround == true then
--[[     ground:setY(sheight)
    ground:destroy()
    ground = nil--]]
    ground:setAngularVelocity(-1)
    ground:setMassFromShapes()
    presentsBox:setAngularVelocity(5)
    logoGround = false
  end
  if love.timer.getTime() > 7.5 then
    love.event.push("q")
  end

  if logoFadeTo > logoFade and logoFade < 255 then
    logoFade = logoFade + 4096 * dt
    if logoFade > 255 then logoFade = 255 end
  end

  world:update(dt)
end

function love.draw()
	gr.setBackgroundColor(logoFade,logoFade,logoFade)

	local fps = love.timer.getFPS()

  if debugVar == true then
    gr.setColor(100,100,100)
    gr.polygon("fill", ground_shape:getPoints())

    for i, g in ipairs(logoBox_shape) do
      gr.setColor(0,0,255,150)
      gr.polygon("fill", g:getPoints())
    end

    for i, g in ipairs(presentsBox_shape) do
      gr.setColor(0,255,0,150)
      gr.polygon("fill", g:getPoints())
    end
  end

	gr.setColor(0,0,0,100)
	gr.drawq(menuLogo, logo[1], _f(logoBox:getX()), _f(logoBox:getY()+8), logoBox:getAngle(), 2, 2, 256, 52)
	gr.drawq(menuLogo, logo[2], _f(presentsBox:getX()), _f(presentsBox:getY()+8), presentsBox:getAngle(), 2, 2, 133, 25)

	gr.setColor(255,255,255)
	gr.drawq(menuLogo, logo[1], _f(logoBox:getX()), _f(logoBox:getY()), logoBox:getAngle(), 2, 2, 256, 52)
	gr.drawq(menuLogo, logo[2], _f(presentsBox:getX()), _f(presentsBox:getY()), presentsBox:getAngle(), 2, 2, 133, 25)

	gr.setColor(0,0,255)
	gr.print("FPS: " .. fps .. "\nTime: " .. love.timer.getTime() .. "\nCount: " .. world:getBodyCount(), 10, 14)
end

function colAdd(a, b)
  print("Collide: " .. a .. ", " .. b)
  if a == "Logo" and b == "Ground" then
    if presentsDropped == false then
      presentsBox:setMassFromShapes()
      presentsDropped = true
      logoFadeTo = 255
    end
  end
end

function colPersist(a, b)
  print("Persist: " .. a .. ", " .. b)
end

function colRemove(a, b)
  print("Remove: " .. a .. ", " .. b)
end

function love.mousepressed(x, y, button)
  if button == "l" then

  end
end

function love.keypressed(k)
	if k == "q" then
	  print("All done! Exiting!")
	  love.event.push("q")
  elseif k == "d" then
    if debugVar == false then debugVar = true else debugVar = false end
	end
end

function degToRad(d) return d * pi / 180 end
